﻿using System;
using System.Collections;
using System.Data;

namespace TestProject
{
    /// <summary>
    /// 직원
    /// </summary>
    public class Employee : IComparable
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 이름
        /// </summary>
        private string firstName;

        /// <summary>
        /// 성
        /// </summary>
        private string lastName;

        /// <summary>
        /// 나이
        /// </summary>
        private int age;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 이름 - FirstName

        /// <summary>
        /// 이름
        /// </summary>
        public string FirstName
        {
            get
            {
                return this.firstName;
            }
            set
            {
                this.firstName = value;
            }
        }

        #endregion
        #region 성 - LastName

        /// <summary>
        /// 성
        /// </summary>
        public string LastName
        {
            get
            {
                return this.lastName;
            }
            set
            {
                this.lastName = value;
            }
        }

        #endregion
        #region 나이 - Age

        /// <summary>
        /// 나이
        /// </summary>
        public int Age
        {
            get
            {
                return this.age;
            }
            set
            {
                this.age = value;
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - Employee(firstName, lastName, age)

        /// <summary>
        /// 생성자
        /// </summary>
        /// <param name="firstName">이름</param>
        /// <param name="lastName">성</param>
        /// <param name="age">나이</param>
        public Employee(string firstName, string lastName, int age)
        {
            this.firstName = firstName;
            this.lastName  = lastName;
            this.age       = age;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region 데이터 테이블 구하기 - GetDataTable()

        /// <summary>
        /// 데이터 테이블 구하기
        /// </summary>
        /// <returns>데이터 테이블</returns>
        public static DataTable GetDataTable()
        {
            DataTable table = new DataTable();

            table.Columns.Add("ProductName", typeof(string  ));
            table.Columns.Add("Quantity"   , typeof(int     ));
            table.Columns.Add("SalesPerson", typeof(Employee));

            table.Rows.Add("Alice Mutton", 250, new Employee("Janet" , "Leverling", 23));
            table.Rows.Add("Geitost"     , 120, new Employee("Andrew", "Fuller"   , 32));
            table.Rows.Add("Chai"        , 70 , new Employee("Anne"  , "Dodsworth", 43));
            table.Rows.Add("Chocolade"   , 15 , new Employee("Andrew", "Fuller"   , 32));
            table.Rows.Add("Filo Mix"    , 9  , new Employee("Anne"  , "Dodsworth", 43));
            table.Rows.Add("Alice Mutton", 63 , new Employee("Andrew", "Fuller"   , 32));
            table.Rows.Add("Chai"        , 99 , new Employee("Janet" , "Leverling", 23));

            return table;
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Instance
        //////////////////////////////////////////////////////////////////////////////// Public

        #region 해시 코드 구하기 - GetHashCode()

        /// <summary>
        /// 해시 코드 구하기
        /// </summary>
        /// <returns>해시 코드</returns>
        public override int GetHashCode()
        {
            return ToString().GetHashCode();
        }

        #endregion
        #region 비교하기 - CompareTo(source)

        /// <summary>
        /// 비교하기
        /// </summary>
        /// <param name="source">소스</param>
        /// <returns>비교 결과</returns>
        public int CompareTo(object source)
        {
            Employee employee = source as Employee;

            return Comparer.Default.Compare(ToString(), employee.ToString());
        }

        #endregion
        #region 상동 여부 구하기 - Equals(source)

        /// <summary>
        /// 상동 여부 구하기
        /// </summary>
        /// <param name="source">소스</param>
        /// <returns>상동 여부</returns>
        public override bool Equals(object source)
        {
            return CompareTo(source) == 0;
        }

        #endregion
        #region 문자열 구하기 - ToString()

        /// <summary>
        /// 문자열 구하기
        /// </summary>
        /// <returns>문자열</returns>
        public override string ToString()
        {
            return this.firstName + ' ' + this.lastName;
        }

        #endregion
    }
}